<?php

namespace app\controllers\mikrotik\mesh;

use yii\helpers\Url;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use app\models\mikrotik\mesh\Port;
use app\models\mikrotik\mesh\Mesh;
use yii\data\ArrayDataProvider;
use app\models\mikrotik\MikrotikSideMenu;
use app\models\mikrotik\interfaces\Ethernet;
use app\models\mikrotik\Interfaces;

class PortController extends Controller {

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'except' => ['index'],
                'rules' => [
                     [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['mikrotik_meshCreatePort'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['mikrotik_meshDeletePort'],
                    ],
                    [
                        'actions' => ['disable'],
                        'allow' => true,
                        'roles' => ['mikrotik_meshDisablePort'],
                    ],
                    [
                        'actions' => ['enable'],
                        'allow' => true,
                        'roles' => ['mikrotik_meshEnablePort'],
                    ],
                     [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['mikrotik_meshUpdatePort'],
                    ],

                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['admin'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    public function actionUpdate() {
        $id = Yii::$app->request->get('id');
        $menu = new MikrotikSideMenu();
        $model = new Port();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $c = $model->update($id);
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/mesh/mesh/index'));
            }
        } else {
            $model->get($id);
        }
        $interface = new Interfaces();
        $int = $interface->names();
        $mesh = new Mesh();
        $m = $mesh->getNames();

        return $this->render('/mikrotik/mesh/port', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'update',
                    'interfaces' => $int,
                    'mesh' => $m,
        ]);
    }

    public function actionCreate() {
        $menu = new MikrotikSideMenu();
        $model = new Port();
        $interface = new Interfaces();
        $int = $interface->names();
        $mesh = new Mesh();
        $m = $mesh->getNames();
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $c = $model->create();
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/mesh/mesh/index'));
            }
        }

        return $this->render('/mikrotik/mesh/port', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'create',
                    'interfaces' => $int,
                    'mesh' => $m,
        ]);
    }

    public function actionDisable() {
        $id = Yii::$app->request->get('id');
        $model = new Port();
        $model->disable($id);
        return $this->redirect(Url::toRoute('mikrotik/mesh/mesh/index'));
    }

    public function actionDelete() {
        $id = Yii::$app->request->get('id');
        $model = new Port();
        $model->delete($id);
        return $this->redirect(Url::toRoute('mikrotik/mesh/mesh/index'));
    }

    public function actionEnable() {
        $id = Yii::$app->request->get('id');
        $model = new Port();
        $model->enable($id);
        return $this->redirect(Url::toRoute('mikrotik/mesh/mesh/index'));
    }

}
